
 /** 
 *<br> Name:	        Mr. Eliot
 *<br> Date:	        10-18-2015, 10-13-2022, 10-13-2023
 *<br> Period:	        ALL
 *<br> Assignment:	    Lesson 06 JavaDocs Example
 *<br> Description:	    PizzaParlor Example for JavaDocs
 *<br> Cite Sources:    ICT Curriculum
 */
 
/**
 * class PizzaParlor - a class used to demonstrate
 * the construction of a class including
 * constructors, methods, and instance variables
 * @author Mr. Eliot
 * @version 1.3
 */

public class PizzaParlor 
{
	// instance variables

	/** holds the name of the pizza parlor*/
	private String myName;
	/** # of cheese pizzas ordered*/
	private int myNumCheesePizzas; 
	/** # of pepperoni pizzas ordered*/
	private int myNumPeppPizzas;
	/** # of veggie pizzas ordered */
	private int myNumVegPizzas;
	/** ounces of cheese in the inventory */
	private int myCheeseSupply;
	/** ounces of pepperoni in the inventory*/
	private int myPepperoniSupply;
	/** ounces of veggies in the inventory*/
	private int myVeggieSupply;
	/** dollars collected for the current set of orders */
	private double myRevenue;
	/** dollars in company bank account */ 
	private double myBankAccount;

	// constructor
	/**
	* <b>summary</b>: default PizzaParlor constructor - creates a PizzaParlor object.  
	* As part of that process, this method initalizes all "global"
	* private values in the class.
	*/ 
	public PizzaParlor()
	{
		myName = "Default Pizza Parlor";
		myNumCheesePizzas = 0;
		myNumPeppPizzas = 0;
		myNumVegPizzas = 0;
		myCheeseSupply = 400;  
		myPepperoniSupply = 200;
		myVeggieSupply = 200;
		myRevenue = 0.0; 
		myBankAccount = 1000.0;
	}


	/**
	* <b>summary</b>: Normal PizzaParlor constructor with arguments - creates a PizzaParlor object.  
	* As part of that process, this method initalizes all "global"
	* private values in the class.  Tester program supplies these parameters.
	* @param Name -- Name of the pizza parlor as a String
	* @param numCheese -- Number of cheese pizzas being ordered as an integer
	* @param numPep -- Number of pepperoni pizzas being ordered as an integer
	* @param numVeg -- Number of veggie pizzas being ordered as an integer
	* @param chSupply -- Cheese supply available to make pizzas as an integer
	* @param pepSupply -- Pepperoni supply available to make pizzas as an integer
	* @param vegSupply -- Vegetable supply available to make pizzas as an integer
	* @param revenue -- Money earned for current set of orders as a double
	* @param bank -- Amount of money the pizza parlor has in the bank as a double
	*/     
	public PizzaParlor(String Name, int numCheese, int numPep, int numVeg, int chSupply, int pepSupply, int vegSupply, double revenue, double bank)
	{
		myName = Name;
		myNumCheesePizzas = numCheese;
		myNumPeppPizzas = numPep;
		myNumVegPizzas = numVeg;
		myCheeseSupply = chSupply;  
		myPepperoniSupply = pepSupply;
		myVeggieSupply = vegSupply;
		myRevenue = revenue + (numCheese * 9.0) + (numPep * 12.0) + (numVeg * 10.0); 
		myBankAccount = myRevenue + bank;
	}

	/**
	* <b>summary</b>: provides a method for ordering cheese pizzas -
	* this updates myRevenue, myBankAccount and 
	* modifies the cheese inventory (myCheeseSupply).
	*/  
	public void orderCheese()
	{
		myNumCheesePizzas++;		//increment number of pizzas
		myRevenue += 9.0; 			//cheese pizza price:$9
		myBankAccount += 9.0;		//update bank account balance
		myCheeseSupply -= 12;		//cheese needed per cheese pizza
	}

	/**
	* <b>summary</b>: provides a method for ordering pepperoni pizzas -
	* this updates myRevenue, myBankAccount and 
	* modifies the cheese inventory (myCheeseSupply) as well
	* as the pepperoni inventory (myPepperoniSupply)
	*/
	public void orderPepperoni()
	{
		myNumPeppPizzas++;			//increment number of pizzas
		myRevenue += 12.0;			//pepperoni pizza price: $12
		myBankAccount += 12.0;		//update bank account balance
		myCheeseSupply -= 8;		//cheese needed per pep pizza
		myPepperoniSupply -= 6;		//pepperoni needed per pep pizza
	}

	/**
	* <b>summary</b>: provides a method ordering veggie pizzas -
	* this updates myRevenue, myBankAccount and 
	* maintains the cheese inventory (myCheeseSupply) as well
	* as the veggie inventory (myVeggieSupply)
	*/
	public void orderVeggie()
	{
		myNumVegPizzas++;			//increment number of pizzas
		myRevenue += 11.0;			//veggie pizza price: $11
		myBankAccount += 10.0;		//update bank account balance
		myCheeseSupply -= 8;		//cheese needed per veggie pizza
		myVeggieSupply -= 12;		//veggies needed per veggie pizza
	}

	/**
	* <b>summary</b>: provides the name of the pizza parlor when asked.
	* @return returns a String with the "name" of the pizza parlor
	*/
	public String getName()
	{
		return myName;
	}

	/**
	* <b>summary</b>: provides a method for obtaining the number
	* of cheese pizzas ordered.
	* @return myNumCheesePizzas the total number of cheese pizzas ordered as an integer
	*/
	public int getNumCheesePizzas()
	{
		return myNumCheesePizzas;
	}
	
	/**
	* <b>summary</b>: provides a method for obtaining the number
	* of pepperoni pizzas ordered.
	* @return myNumPeppPizzas the total number of pepperoni pizzas ordered as an integer
	*/
	public int getNumPepperoniPizzas()
	{
		return myNumPeppPizzas;
	}

	/**
	* <b>summary</b>: provides a method for obtaining the number
	* of veggie pizzas ordered.
	* @return myNumVegPizzas the total number of veggie pizzas ordered as an integer
	*/
	public int getNumVeggiePizzas()
	{
		return myNumVegPizzas;
	}

	/**
	* <b>summary</b>: provides a method for tracking the supply of cheese
	* @return myCheeseSupply the total number of ounces of cheese in stock as an integer
	*/
	public int getCheeseSupply()
	{
		return myCheeseSupply;
	}

	/**
	* <b>summary</b>: provides a method for tracking the supply of pepperoni
	* @return myPepperoniSupply the total number of ounces of pepperoni in stock as an integer
	*/
	public int getPepperoniSupply()
	{
		return myPepperoniSupply;
	}

	/**
	* <b>summary</b>: provides a method for tracking the supply of veggies
	* @return myVeggieSupply the total number of ounces of veggies in stock as an integer
	*/
	public int getVeggieSupply()
	{
		return myVeggieSupply;
	}

	/**
	* <b>summary</b>: provides a method for tracking the dollars collected from these pizza orders
	* @return myRevenue the total money collected for the current set of pizza orders as a double
	*/
	public double getRevenueTotal()
	{
		return myRevenue;
	}

	/**
	* <b>summary</b>: provides a method for tracking the money in the pizza parlor bank account
	* @return myBankAccount the total money in the pizza parlor bank account as a double
	*/
	public double getBankAccountBalance()
	{
		return myBankAccount;
	}
}

